/**
 * Created by paul.lashbrook on 12/12/13.
 */
// used to make requests to Xonder
var https = require('https');

// required to make a signature
var hash = require('crypto');

// preshared key set in the merchant's mms
var pre_shared_key = 'Circle4Take40Idea';

// payment information
var post_data = {
    'action': 'SALE',
    'amount' : 1000,
    'merchantID': 100001,
    'type' : 1,
    'currencyCode' : 826,
    'countryCode' : 826,
    'cardNumber' : 4929421234600821,
    'cardExpiryMonth' : 12,
    'cardExpiryYear' : 15,
    'cardCVV' : 356,
    'customerName' : "Xonder",
    'customerPhone' : "+44 (0) 8450099575",
    'customerAddress' : "6347 Test Card Street",
    'customerPostCode' : "17T ST8"
}

// get the keys in the object
var items = Object.keys(post_data);

var string = '';

// sort the array of keys
items.sort();

// for each key loop over in order
items.forEach(function(item) {
    string += item + '=' + encodeURIComponent(post_data[item]) + '&';
});

// remove the trailing &
string = string.slice(0,-1);

// below replaces are to ensure the escaping is the same as php's http_build_query()
string = string.replace(/\(/g, "%28");
string = string.replace(/\)/g, "%29");
string = string.replace(/%20/g, "+");

// make the new string
post_data = string + '&signature=' + hash.createHash('SHA512').update(string + pre_shared_key).digest('hex');

// http request options
var options = {
    hostname: 'mms.xonder.net',
    port: 443,
    path: '/direct/',
    method: 'POST',
    headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Content-Length': post_data.length
    }
}

// open the request
var req = https.request(options, function(res) {
    console.log("statusCode: ", res.statusCode);
    console.log("headers: ", res.headers);

    res.on('data', function(d) {
        process.stdout.write(d);
    });

});

// send the post data
req.write(post_data);

req.end();

req.on('error', function(e) {
    console.error(e);
});
